/* 38.exe */
/* manda a capo le righe alla colonna 39. Non supporta codifiche multibyte */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

short limit = 38;
char *infile, *outfile;
char retchar[] = "\x0d\x0a"; // DOS/Win return

/* come strstr, ma si limita ai primi lim byte di where. */
/* Tempo = O(min(lim,strlen(where))) */
char *lstrstr(char *where, const char *what, int lim) {
  int p=0,psave,i;
  if (what[0] == 0) return where;
  if (lim == 0) return NULL;

  while (1) {
    while (where[p] != 0 && where[p] != what[0] && p < lim) p++;

    if (where[p] == 0 || p >= lim) break;
    i = 0, psave = p;
    while (what[i] != 0 && where[p] == what[i] && p < lim) p++, i++;
    if (what[i] == 0) return where+psave;
    if (p >= lim) break;
  }
  return NULL;
}

void error(int id, char *p) {
  printf("Errore. ");
  switch (id) {
    case 0: puts("Nessun errore"); break;
    case 1: puts("Sintassi errata"); break;
    case 2: puts("Nessun file trovato"); break;
    case 5: printf("Impossibile aprire il file %s\n", p); break;
    case 6: printf("Il file %s esiste gia'\n", p); break;
    case 7: puts("Memoria esaurita"); break;
  }
}

void print_usage() {
  puts("38  1.0  Ottobre 2008 - Manda a capo le righe lunghe\n\n"
    "SINTASSI:\n"
    "  38 [opzioni] inputfile outputfile\n"
    "    inputfile e' il file con le righe lunghe,\n"
    "    outputfile è' il file in uscita;\n"
    "   opzioni:\n"
    "     -l limit    imposta il limite delle colonne a limit (default: 38)\n");
  exit(0);
}

void parse_args(int argc, char *argv[]) {
  int i;

  if (argc == 1) print_usage();
  if (argc <= 2) {
    error(1, NULL);
    print_usage();
  }
  outfile = argv[--argc];
  infile = argv[--argc];
  
  /* reads options */
  for (i=1; i<argc; i++) {
    if (argv[i][0] != '-') {
      error(1, NULL);
      print_usage();
    }
    switch (argv[i][1]) {
      case 'l':
        if (i == argc-1) { error(1, NULL); print_usage(); }
        limit = atoi(argv[++i]);
       break;
      default:
        error(1, NULL);
        print_usage();
    }
  }
}

void dosplit() {
  FILE *fin, *fout;
  int rows = 0, ptr=0;
  char rowbuf[50], buf[1024+limit+16];
  
  if ((fin = fopen(infile, "r")) == NULL) {
    error(5, infile);
    exit(1);
  }
  if ((fout = fopen(outfile, "w")) == NULL) {
    error(5, outfile);
    exit(1);
  }
  while (!feof(fin)) {
    //fgets(buf+ptr, 1024, fin);
    int bread = fread(buf+ptr, 1, 1024, fin);
    *(buf+ptr+bread) = 0;
    int buflen = strlen(buf);
    int pos = 0;
    for (;;) {
      
      char *retpos = lstrstr(buf+pos, retchar, limit+strlen(retchar));
      if (retpos == NULL) {
        if (buflen-pos < limit) {
          memmove(buf, buf+pos, buflen-pos);
          ptr = buflen-pos;
          break;
        } else {
          strncpy(rowbuf, buf+pos, limit);
          rowbuf[limit] = 0;
          strcat(rowbuf, retchar);
          fputs(rowbuf, fout);
          rows++;
          pos += limit;
        }
      } else {
        int len = retpos-buf-pos;
        strncpy(rowbuf, buf+pos, len);
        rowbuf[len] = 0;
        strcat(rowbuf, retchar);
        fputs(rowbuf, fout);
        rows++;
        pos += len+strlen(retchar);
      }
    }
    if (feof(fin)) {
      *(buf+ptr) = 0;
      strcat(buf, retchar);
      fputs(buf, fout);
      rows++;
      break;
    }
  }
  fclose(fin);
  fclose(fout);
  printf("Scritte %i righe.\n", rows);
}

int main(int argc, char *argv[]) {
  parse_args(argc, argv);
  dosplit();
  return 0;
}