#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/io.h>

unsigned char cmos_getbyte(int offset) {
  outb(offset, 0x70);
  return inb(0x71);
}

int main(int argc, char *argv[]) {
  int i,j=0, hexform=0;
  int start = 0x00,
      end = 0x7f;
  
  for (i=1; i<argc; i++) {
    if (strcmp(argv[i], "--help") == 0) {
      printf("Syntax: %s [--hex] [start [end]]\n",argv[0]);
      return(0);
    } else if (strcmp(argv[i], "--hex") == 0) {
      hexform = 1;
    } else {
      if (j) end = atoi(argv[i]);
      else { start = atoi(argv[i]); j=1; }
    }
  }
  
  if (ioperm(0x70,2, 1) < 0) {
    fprintf(stderr, "You must be root.\n");
    return -1;
  }
  for (i=start; i<=end; i++) 
    if (hexform) printf("%02hhx ",cmos_getbyte(i)); 
    else fputc(cmos_getbyte(i), stdout);
  fputc('\n', stdout);
  
  return(0);
}
